/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
ե̾: score.c
⥸塼̾ : score
ǽ: 
: ʡϺ
ѹ: ã
*******************************************************************************/
#ifdef	NO_CURSES
#include	<stdio.h>
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#include	<time.h>
#include	"yumihead.h"

char *advice(rate, notohpm)
int rate, notohpm;
{
	if (rate > 50) {
		return "㤯Ǥ͡äǤɤ͡";
        } else if (rate > 20) {
		return "äȡäǤäƤ";
	} else if (rate > 10) {
		return "ΤǤ͡⤦ΤǤͤˤƲ";
	} else if (notohpm < 10) {
		return "ƤΤǤ͵ܤäƤޤ衣";
	} else if (notohpm < 20) {
		return "ޤʤ͵ˤޤ衣";
	} else if (notohpm < 40) {
		return "äǤܻ͡ؤǤäƤΤǤ";
	} else if (notohpm < 60) {
		return "ˤäƤޤ٤ޤ";
	} else if (notohpm < 80) {
		return "ΤޤʥפǤ͡­ǤäƤΤǤ";
	} else if (notohpm < 100) {
		return "ä٤Ǥ͡Фޤ礦";
	} else if (notohpm < 120) {
		return "ޤޤΤǤǤˤФä褦";
	} else if (notohpm < 150) {
		return "ʤǤ褦ˤʤޤ͡";
	} else if (notohpm < 180) {
		return "ޤ͡⤦Ǥ";
	} else if (notohpm < 200) {
		return "Ȱ©ǴǤ";
	} else if (notohpm < 240) {
		return "Ǥ͵θĿͶƲ";
	} else if (notohpm < 280) {
		return "Ф餷ɤƤʤ᤯ǤƤΡ";
	} else if (notohpm < 300) {
		return "פŷ͡ ޤ";
	} else {
		return "פФꤻ¾ΤȤٶʤ:-)";
	}
}

void logtrain(TOS, TOE, NOTOH, NOMTOH, MISS, title, level, handy)
long	TOS, TOE;
long	NOTOH, NOMTOH;
unsigned char MISS[];
char   *title;
int	level;
int	handy;
{
	long	sot;		/* spawn of time */
	int	notohpm;	/* Number of Touch per Minute */
	int	nortoh;		/* Number of Right Touch */
	double	rate;
	int	irate;
	int	ch;
	int	i;
	int	weak;
	int	point;
	extern int int_flag;

	/* calucurate training time */
	if((sot = TOE - TOS) <= 0) sot = 1;

	/* calucurate number of touch per 1 minute */
	if (NOMTOH > NOTOH) NOMTOH = NOTOH;
	nortoh = NOTOH - NOMTOH;
	notohpm = (double)nortoh / (double)sot * 60.0;

	/* calucurate rate of misstouch */
	if(NOTOH != 0)
		rate = ((double)NOMTOH * 100.0) / (double)NOTOH;
	else
		rate = 0.0;

	/* display the result of test */
	clear();
	mvaddstr(3, 10, " :");
	mvprintw(3, 54, "%ld ʬ %ld ", sot/60, sot%60);
	mvaddstr(5, 10, "å :");
	mvprintw(5, 54, "%d å", nortoh);
	mvaddstr(7, 10, "1ʬ֤å :");
	mvprintw(7, 54, "%d å/ʬ", notohpm);
	mvaddstr(9, 10, "ߥå :");
	mvprintw(9, 54, "%d å", NOMTOH);
	mvaddstr(11, 10, "åФߥåγ :");
	irate = rate * 10;
	mvprintw(11, 54, "%d.%d%%", irate/10, irate%10);
	irate = irate/10;
	weak = FALSE;
	for(i = 0x20; i < 127; i++) {
		if (MISS[i]) {
			if (!weak) {
				weak = TRUE;
				mvaddstr(13, 10, "ʸϼΤȤǤ: ");
			}
			addch(i);
		}
	}
	if (handy > 0) {
		notohpm = notohpm * handy / 100;
	}
	mvprintw(15, 10, "ɥХ : %s", advice(irate, notohpm));
	point = notohpm * 100 / 225 - irate * 2;
	if (point < 0) point = 0;
	mvaddstr(17, 10, " :");
	if (point > 100) {
		mvprintw(17, 54, "100+%d", point-100);
	}
	else {
		mvprintw(17, 54, "%3d", point);
	}
	menu_expand_level(level);
	if (level_table[level].point >= 0) {
		mvaddstr(19, 10, "ޤǤκǹ :");
		if (level_table[level].point > 100) {
			mvprintw(19, 54, "100+%d", level_table[level].point-100);
		}
		else {
			mvprintw(19, 54, "%3d", level_table[level].point);
		}
	}
	if (point > level_table[level].point ||
	    (level_table[level].title &&
	     strcmp(title, level_table[level].title) != 0)) {
		level_table[level].point = point;
		level_table[level].date = TOS;
		if (level_table[level].title) {
			free(level_table[level].title);
		}
		level_table[level].title = (char *)malloc(strlen(title)+1);
		strcpy(level_table[level].title, title);
		menu_store_level();
	}
	standout();
	if (point >= 90) {
		mvaddstr(21, 10, "饤!! Υƥåפ˿ʤǲ");
	}
	else if (point >= 80) {
		mvaddstr(21, 10, "ʤǤΥƥåפ˿ʤǤ⤫ޤޤ");
	}
	else if (point >= 60) {
		mvaddstr(21, 10, "⤦ĥޤ礦");
	}
	else {
		mvaddstr(21, 10, "Թʡ⤦٤äƤߤޤ礦");
	}
	standend();
	mvaddstr(LINES-1, 0, "꥿󥭡ϤƤ");
	refresh();
	int_flag = FALSE;
	while ((ch = getch()) != '\n' && ch != '\r' && ch != EOF && !int_flag);
}

